
open Terms;;
open Monitor;;

(*********** KAM ***********)

type clos = Clos of env * lambda
 and env  = clos list
;;

let rec clos_rel = function
  ((c::_), 0) -> inc "defined"; c
| ((_::e), n) -> clos_rel (e, n-1)
| ([], n) -> inc "clos"; Clos([], Rel n)
;;
let mk_clos e = function
    Rel i -> inc "expand"; clos_rel (e,i)
  | b -> inc "clos"; Clos(e,b)
;;

type stk =
    Ztop
  | Zapp of lambda * stk
  | Zlam of stk
  | Zarg of clos * stk
;;

let k  = ref 0;;
let ge = ref [];;
let gs = ref Ztop;;

let rec kni = function
| App(a,b) ->
inc "app";
    gs := Zarg (mk_clos !ge b, !gs);
    kni a
| Lam f ->
    (match !gs with
       Zarg(arg,s) ->
inc "beta";
         ge := arg :: !ge;
         gs := s;
         kni f
     | s ->
inc "clos";
         k  := !k + 1;
         ge := (Clos ([], Rel(- !k))) :: !ge;
         gs := Zlam s;
         kni f)
| Rel i -> inc "expand"; kni_rel (!ge, i)

and kni_rel = function
  (((Clos(e,t))::_), 0) ->
inc "defined";
    ge := e;
    kni t
| ((_::e), i) -> kni_rel (e, i-1)
| ([], i) -> zip (Rel(i + !k))

and zip t =
  match !gs with
    Ztop -> t
  | Zapp(a,s) ->
      gs := s;
      zip (App(a,t))
  | Zlam s ->
      k  := !k - 1;
      gs := s;
      zip (Lam t)
  | Zarg(Clos(e,u), s) ->
      ge := e;
      gs := Zapp(t,s);
      kni u
;;

let nkam t =
init();
  k  := 0; (* useless initialization *)
  ge := [];
  gs := Ztop;
  kni t
;;

let skn t = nkam t; stat();;

