
(* Monitoring... *)
let mem_val () =
  let st = Gc.stat() in
    st.Gc.minor_words + st.Gc.major_words - st.Gc.promoted_words
;;
let mem = ref 0;;


let refs = ref [];;
let add_ref s =
  let r = ref 0 in 
    refs := (s,r) :: !refs;
    r
;;
let init() =
  mem := mem_val();
  List.iter (fun (_,r) -> r := 0) !refs;;

let stat() =
  print_string "Memory: ";
  print_int (mem_val() - !mem);
    print_newline();
    List.iter
      (fun (s,r) ->
         print_string (s^" = ");
         print_int !r;
         print_newline())
      !refs
;;

let rec inc s =
  try incr (List.assoc s !refs)
  with Not_found -> incr (add_ref s)
;;

