
let rec iter f x = function
    0 -> x
  | n -> iter f (f x) (n-1)
;;

type lambda =
    Rel of int
  | Lam of lambda
  | App of lambda * lambda
;;

let bin_app a b c = App(App(a,b),c);;
let app_list h t = List.fold_left (fun h arg -> App(h,arg)) h t;;
let lam_list n t = iter (fun x -> Lam x) t n;;


let rec lift n k = function
    Rel i -> if i<k then Rel i else Rel (i+n)
  | Lam t -> Lam (lift n (k+1) t)
  | App(a,b) -> App(lift n k a, lift n k b)
;;
let lift n k t = if n = 0 then t else lift n k t
